# StochasticDiffEqIIF.jl

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/DiffEqDocs/stable/solvers/sde_solve/)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

StochasticDiffEqIIF.jl is a component of the [OrdinaryDiffEq.jl](https://github.com/SciML/OrdinaryDiffEq.jl) monorepo providing integrating factor methods for stochastic differential equations with semi-linear structure. While completely independent and usable on its own, users wanting all SDE solvers should use [StochasticDiffEq.jl](https://github.com/SciML/StochasticDiffEq.jl).

## Solvers

- `IIF1M` - Implicit Integrating Factor Euler-Maruyama
- `IIF2M` - Implicit Integrating Factor order 2
- `IIF1Mil` - Implicit Integrating Factor Milstein

These methods are designed for SDEs of the form `du = (Au + f(u,p,t))dt + g(u,p,t)dW` where `A` is a linear operator, leveraging the integrating factor `exp(At)` to handle the linear part exactly.

## Example

```julia
using StochasticDiffEqIIF, LinearAlgebra
A = [-1.0 0.0; 0.0 -2.0]
f = SplitFunction(DiffEqArrayOperator(A), (du, u, p, t) -> du .= 0.1 .* u)
g(du, u, p, t) = du .= 0.1 .* u
u0 = [1.0, 1.0]
tspan = (0.0, 1.0)
prob = SDEProblem(f, g, u0, tspan)
sol = solve(prob, IIF1M(), dt = 0.01)
```

## Available Solvers

For the full list of available SDE solvers, refer to the [DifferentialEquations.jl SDE Solvers](https://docs.sciml.ai/DiffEqDocs/stable/solvers/sde_solve/) documentation.

"""
    IIF1M(;nlsolve=NLSOLVEJL_SETUP())

**IIF1M: Integrating Factor Method 1 (Semi-Linear)**

First-order integrating factor method for semi-linear SDEs with stiff linear parts.

## Method Properties

  - **Strong Order**: 1.0
  - **Weak Order**: 1.0
  - **Time stepping**: Fixed or adaptive
  - **Problem type**: Semi-linear SDEs with stiff linear components
  - **Treatment**: Exponential integrator approach

## Parameters

  - `nlsolve`: Nonlinear solver configuration

## When to Use

  - Semi-linear SDEs: du = (L*u + N(u))dt + g(u)dW where L is stiff linear operator
  - Problems amenable to integrating factor techniques
  - When exponential integrators are appropriate
  - Stiff linear parts with nonlinear perturbations

## Algorithm Description

Applies integrating factor exp(L*t) to handle stiff linear part exactly while treating nonlinear parts numerically.

## References

  - Integrating factor methods for stiff SDEs
"""
struct IIF1M{F} <: StochasticDiffEqAlgorithm
    nlsolve::F
end
IIF1M(; nlsolve = NLSOLVEJL_SETUP()) = IIF1M{typeof(nlsolve)}(nlsolve)

"""
    IIF2M(;nlsolve=NLSOLVEJL_SETUP())

**IIF2M: Integrating Factor Method 2 (Semi-Linear)**

Second-order integrating factor method for semi-linear SDEs.

## Method Properties

  - **Strong Order**: 2.0
  - **Weak Order**: 2.0
  - **Time stepping**: Fixed or adaptive
  - **Problem type**: Semi-linear SDEs with stiff linear components
  - **Treatment**: Higher-order exponential integrator

## Parameters

  - `nlsolve`: Nonlinear solver configuration

## When to Use

  - When higher accuracy than IIF1M is needed
  - Semi-linear problems requiring second-order convergence
  - More expensive but more accurate than IIF1M

## References

  - Higher-order integrating factor methods for SDEs
"""
struct IIF2M{F} <: StochasticDiffEqAlgorithm
    nlsolve::F
end
IIF2M(; nlsolve = NLSOLVEJL_SETUP()) = IIF2M{typeof(nlsolve)}(nlsolve)

"""
    IIF1Mil(;nlsolve=NLSOLVEJL_SETUP())

**IIF1Mil: Integrating Factor Milstein Method (Semi-Linear)**

Integrating factor method combined with Milstein correction for semi-linear SDEs.

## Method Properties

  - **Strong Order**: 1.0 (with Milstein correction)
  - **Weak Order**: 1.0
  - **Time stepping**: Fixed or adaptive
  - **Problem type**: Semi-linear SDEs with stiff linear components
  - **Treatment**: Exponential integrator with Milstein correction

## Parameters

  - `nlsolve`: Nonlinear solver configuration

## When to Use

  - Semi-linear SDEs requiring Milstein-type accuracy
  - When both stiff linear treatment and higher-order stochastic accuracy are needed
  - Alternative to IIF1M with enhanced stochastic treatment

## References

  - Integrating factor methods with Milstein correction
"""
struct IIF1Mil{F} <: StochasticDiffEqAlgorithm
    nlsolve::F
end
IIF1Mil(; nlsolve = NLSOLVEJL_SETUP()) = IIF1Mil{typeof(nlsolve)}(nlsolve)

mutable struct RHS_IIF1M_Scalar{F, CType, tType, P} <: Function
    f::F
    t::tType
    dt::tType
    tmp::CType
    p::P
end

function (f::RHS_IIF1M_Scalar)(resid, u)
    return resid[1] = u[1] - f.tmp - f.dt * f.f.f2(u[1], f.p, f.t + f.dt)[1]
end

mutable struct RHS_IIF2M_Scalar{F, CType, tType, P} <: Function
    f::F
    t::tType
    dt::tType
    tmp::CType
    p::P
end

function (f::RHS_IIF2M_Scalar)(resid, u)
    return resid[1] = u[1] - f.tmp - 0.5f.dt * f.f.f2(u[1], f.p, f.t + f.dt)[1]
end

@muladd function initialize!(
        integrator, cache::Union{
            IIF1MConstantCache, IIF2MConstantCache, IIF1MilConstantCache,
        }
    )
    cache.uhold[1] = integrator.uprev
end

@muladd function perform_step!(
        integrator, cache::Union{
            IIF1MConstantCache, IIF2MConstantCache, IIF1MilConstantCache,
        }
    )
    (; t, dt, uprev, u, W, p, f) = integrator
    (; uhold, rhs, nl_rhs) = cache
    alg = unwrap_alg(integrator, true)
    A = integrator.f.f1(u, p, t)
    if cache isa IIF1MilConstantCache
        error("Milstein correction does not work.")
    elseif cache isa IIF1MConstantCache
        tmp = exp(A * dt) * (uprev + integrator.f.g(uprev, p, t) * W.dW)
    elseif cache isa IIF2MConstantCache
        tmp = exp(A * dt) * (uprev + 0.5dt * integrator.f.f2(uprev, p, t) + integrator.f.g(uprev, p, t) * W.dW)
    end

    if integrator.iter > 1 && !integrator.u_modified
        uhold[1] = current_extrapolant(t + dt, integrator)
    end # else uhold is previous value.

    rhs.t = t
    rhs.dt = dt
    rhs.tmp = tmp
    nlres = alg.nlsolve(nl_rhs, uhold)

    u = nlres[1]
    integrator.u = u
end

mutable struct RHS_IIF1{F, uType, tType, DiffCacheType, SizeType, P} <: Function
    f::F
    tmp::uType
    t::tType
    dt::tType
    dual_cache::DiffCacheType
    sizeu::SizeType
    p::P
end
function (f::RHS_IIF1)(resid, u)
    _du = get_du(f.dual_cache, eltype(u))
    du = reinterpret(eltype(u), _du)
    f.f.f2(du, reshape(u, f.sizeu), f.p, f.t + f.dt)
    return @.. resid = u - f.tmp - f.dt * du
end

mutable struct RHS_IIF2{F, uType, tType, DiffCacheType, SizeType, P} <: Function
    f::F
    tmp::uType
    t::tType
    dt::tType
    dual_cache::DiffCacheType
    sizeu::SizeType
    p::P
end
function (f::RHS_IIF2)(resid, u)
    _du = get_du(f.dual_cache, eltype(u))
    du = reinterpret(eltype(u), _du)
    f.f.f2(du, reshape(u, f.sizeu), f.p, f.t + f.dt)
    return @.. resid = u - f.tmp - 0.5f.dt * du
end

@muladd function perform_step!(integrator, cache::Union{IIF1MCache, IIF2MCache})
    (; rtmp1, rtmp2, rtmp3, tmp, noise_tmp) = cache
    (; uhold, rhs, nl_rhs) = cache
    (; t, dt, uprev, u, W, p, f) = integrator
    alg = unwrap_alg(integrator, true)
    uidx = eachindex(u)

    integrator.f.g(rtmp2, uprev, p, t)

    if is_diagonal_noise(integrator.sol.prob)
        rmul!(rtmp2, W.dW) # rtmp2 === rtmp3
    else
        mul!(rtmp3, rtmp2, W.dW)
    end

    rtmp3 .+= uprev

    if cache isa IIF2MCache
        integrator.f.f2(rtmp1, uprev, p, t)
        dto2 = dt / 2
        @.. rtmp3 = dto2 * rtmp1 + rtmp3
    end

    A = integrator.f.f1(rtmp1, uprev, p, t)
    M = exp(A * dt)
    mul!(tmp, M, rtmp3)

    if integrator.iter > 1 && !integrator.u_modified
        current_extrapolant!(uhold, t + dt, integrator)
    end # else uhold is previous value.

    rhs.t = t
    rhs.dt = dt
    rhs.tmp = tmp
    rhs.sizeu = size(u)
    nlres = alg.nlsolve(nl_rhs, uhold)

    copyto!(uhold, nlres)
end

@muladd function perform_step!(integrator, cache::IIF1MilCache)
    (; rtmp1, rtmp2, rtmp3, tmp, noise_tmp) = cache
    (; uhold, rhs, nl_rhs) = cache
    (; t, dt, uprev, u, W, p, f) = integrator
    alg = unwrap_alg(integrator, true)

    dW = W.dW
    sqdt = integrator.sqdt
    f = integrator.f
    g = integrator.f.g

    A = integrator.f.f1(t, uprev, rtmp1)
    M = exp(A * dt)

    uidx = eachindex(u)
    integrator.f.g(rtmp2, uprev, p, t)
    if cache isa Union{IIF1MCache, IIF2MCache}
        if is_diagonal_noise(integrator.sol.prob)
            rmul!(rtmp2, W.dW) # rtmp2 === rtmp3
        else
            mul!(rtmp3, rtmp2, W.dW)
        end
    else #Milstein correction
        rtmp2 = M * rtmp2 # mul!(rtmp2,M,gtmp)
        (; gtmp, gtmp2) = cache
        #error("Milstein correction does not work.")
        mul!(rtmp3, rtmp2, W.dW)
        I = zeros(length(dW), length(dW))
        Dg = zeros(length(dW), length(dW))
        mil_correction = zeros(length(dW))
        mil_correction .= 0.0
        for i in 1:length(dW), j in 1:length(dW)

            I[j, i] = 0.5 * dW[i] * dW[j]
            j == i && (I[i, i] -= 0.5 * dt) # Ito correction
        end
        for j in 1:length(uprev)
            #Kj = uprev .+ dt.*du1 + sqdt*rtmp2[:,j] # This works too
            Kj = uprev .+ sqdt * rtmp2[:, j]
            g(gtmp, Kj, p, t)
            mul!(gtmp2, M, gtmp)
            Dgj = (gtmp2 - rtmp2) / sqdt
            mil_correction .+= Dgj * I[:, j]
        end
        rtmp3 .+= mil_correction
    end

    if cache isa IIF2MCache
        integrator.f.f2(t, uprev, rtmp1)
        dto2 = dt / 2
        @.. rtmp1 = dto2 * rtmp1 + uprev + rtmp3
        mul!(tmp, M, rtmp1)
    elseif !(cache isa IIF1MilCache)
        @.. rtmp1 = uprev + rtmp3
        mul!(tmp, M, rtmp1)
    else
        mul!(tmp, M, uprev)
        tmp .+= rtmp3
    end

    if integrator.iter > 1 && !integrator.u_modified
        current_extrapolant!(uhold, t + dt, integrator)
    end # else uhold is previous value.

    rhs.t = t
    rhs.dt = dt
    rhs.tmp = tmp
    rhs.sizeu = size(u)
    nlres = alg.nlsolve(nl_rhs, uhold)

    copyto!(uhold, nlres)
end

module StochasticDiffEqIIF

using Reexport
@reexport using StochasticDiffEqCore

import OrdinaryDiffEqCore
import OrdinaryDiffEqCore: perform_step!, initialize!, issplit,
    current_extrapolant, current_extrapolant!

import StochasticDiffEqCore: alg_cache, alg_order, alg_compatible,
    alg_needs_extra_process,
    StochasticDiffEqAlgorithm, StochasticDiffEqAdaptiveAlgorithm,
    StochasticDiffEqCache, StochasticDiffEqConstantCache, StochasticDiffEqMutableCache,
    NLSOLVEJL_SETUP, IIFNLSolveFunc, DiffCache, get_du, get_chunksize,
    determine_chunksize, unwrap_alg,
    @cache

import DiffEqBase: is_diagonal_noise, @..
import DiffEqBase: full_cache, rand_cache, ratenoise_cache

import MuladdMacro: @muladd
import SciMLBase

using LinearAlgebra
using RecursiveArrayTools

include("algorithms.jl")
include("alg_utils.jl")
include("caches/iif_caches.jl")
include("perform_step/iif.jl")

export IIF1M, IIF2M, IIF1Mil

end # module

struct IIF1MConstantCache{vecuType, rhsType, nl_rhsType} <: StochasticDiffEqConstantCache
    uhold::vecuType
    rhs::rhsType
    nl_rhs::nl_rhsType
end

@cache struct IIF1MCache{
        uType, vecuType, DiffCacheType, rhsType, nl_rhsType, rateType,
        rateNoiseType, rateNoiseCollectionType, NoiseTmpType,
    } <: StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    uhold::vecuType
    dual_cache::DiffCacheType
    tmp::uType
    rhs::rhsType
    nl_rhs::nl_rhsType
    rtmp1::rateType
    rtmp2::rateNoiseType
    rtmp3::rateNoiseCollectionType
    noise_tmp::NoiseTmpType
end

function alg_cache(
        alg::IIF1M, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    uhold = Vector{typeof(u)}(undef, 1)
    tmp = zero(rate_prototype)
    rhs = RHS_IIF1M_Scalar(f, t, t, tmp, p)
    nl_rhs = alg.nlsolve(Val{:init}, rhs, uhold)
    return IIF1MConstantCache(uhold, rhs, nl_rhs)
end

function alg_cache(
        alg::IIF1M, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = similar(u, axes(u))
    rtmp1 = zero(rate_prototype)
    dual_cache = DiffCache(u, Val{determine_chunksize(u, get_chunksize(alg.nlsolve))})
    uhold = vec(u) # this makes uhold the same values as integrator.u
    rhs = RHS_IIF1(f, tmp, t, t, dual_cache, size(u), p)
    nl_rhs = alg.nlsolve(Val{:init}, rhs, uhold)
    noise_tmp = tmp

    rtmp2 = zero(noise_rate_prototype)
    if is_diagonal_noise(prob)
        rtmp3 = rtmp2
    else
        rtmp3 = zero(rate_prototype)
    end
    return IIF1MCache(
        u, uprev, uhold, dual_cache, tmp, rhs, nl_rhs, rtmp1, rtmp2, rtmp3, noise_tmp
    )
end

struct IIF2MConstantCache{vecuType, rhsType, nl_rhsType} <: StochasticDiffEqConstantCache
    uhold::vecuType
    rhs::rhsType
    nl_rhs::nl_rhsType
end

@cache struct IIF2MCache{
        uType, vecuType, DiffCacheType, rhsType, nl_rhsType, rateType,
        rateNoiseType, rateNoiseCollectionType, NoiseTmpType,
    } <: StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    uhold::vecuType
    dual_cache::DiffCacheType
    tmp::uType
    rhs::rhsType
    nl_rhs::nl_rhsType
    rtmp1::rateType
    rtmp2::rateNoiseType
    rtmp3::rateNoiseCollectionType
    noise_tmp::NoiseTmpType
end

function alg_cache(
        alg::IIF2M, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    uhold = Vector{typeof(u)}(undef, 1)
    tmp = zero(rate_prototype)
    rhs = RHS_IIF2M_Scalar(f, t, t, tmp, p)
    nl_rhs = alg.nlsolve(Val{:init}, rhs, uhold)
    return IIF2MConstantCache(uhold, rhs, nl_rhs)
end

function alg_cache(
        alg::IIF2M, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = similar(u, axes(u))
    rtmp1 = zero(rate_prototype)
    dual_cache = DiffCache(u, Val{determine_chunksize(u, get_chunksize(alg.nlsolve))})
    uhold = vec(u) # this makes uhold the same values as integrator.u
    rhs = RHS_IIF2(f, tmp, t, t, dual_cache, size(u), p)
    nl_rhs = alg.nlsolve(Val{:init}, rhs, uhold)
    noise_tmp = tmp

    rtmp2 = zero(noise_rate_prototype)
    if is_diagonal_noise(prob)
        rtmp3 = rtmp2
    else
        rtmp3 = zero(rate_prototype)
    end
    return IIF2MCache(
        u, uprev, uhold, dual_cache, tmp, rhs, nl_rhs, rtmp1, rtmp2, rtmp3, noise_tmp
    )
end

struct IIF1MilConstantCache{vecuType, rhsType, nl_rhsType} <: StochasticDiffEqConstantCache
    uhold::vecuType
    rhs::rhsType
    nl_rhs::nl_rhsType
end

@cache struct IIF1MilCache{
        uType, vecuType, DiffCacheType, rhsType, nl_rhsType, rateType,
        rateNoiseType, rateNoiseCollectionType, NoiseTmpType,
    } <: StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    uhold::vecuType
    dual_cache::DiffCacheType
    tmp::uType
    rhs::rhsType
    nl_rhs::nl_rhsType
    rtmp1::rateType
    rtmp2::rateNoiseType
    rtmp3::rateNoiseCollectionType
    noise_tmp::NoiseTmpType
    gtmp::rateNoiseType
    gtmp2::rateNoiseType
end

function alg_cache(
        alg::IIF1Mil, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    uhold = Vector{typeof(u)}(undef, 1)
    C = zero(rate_prototype)
    rhs = RHS_IIF1M_Scalar(f, t, t, C, p)
    nl_rhs = alg.nlsolve(Val{:init}, rhs, uhold)
    return IIF1MilConstantCache(uhold, rhs, nl_rhs)
end

function alg_cache(
        alg::IIF1Mil, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = similar(u, axes(u))
    rtmp1 = zero(rate_prototype)
    dual_cache = DiffCache(u, Val{determine_chunksize(u, get_chunksize(alg.nlsolve))})
    uhold = vec(u) # this makes uhold the same values as integrator.u
    rhs = RHS_IIF1(f, tmp, t, t, dual_cache, size(u), p)
    nl_rhs = alg.nlsolve(Val{:init}, rhs, uhold)
    noise_tmp = zero(noise_rate_prototype)
    gtmp = zero(noise_rate_prototype)
    gtmp2 = zero(noise_rate_prototype)
    rtmp2 = zero(noise_rate_prototype)
    if is_diagonal_noise(prob)
        rtmp3 = rtmp2
    else
        rtmp3 = zero(rate_prototype)
    end
    return IIF1MilCache(
        u, uprev, uhold, dual_cache, tmp, rhs, nl_rhs,
        rtmp1, rtmp2, rtmp3, noise_tmp, gtmp, gtmp2
    )
end

using SafeTestsets

const TEST_GROUP = get(ENV, "ODEDIFFEQ_TEST_GROUP", "ALL")

if TEST_GROUP == "ALL" || TEST_GROUP == "Core"
    @time @safetestset "Module loads and constructors" begin
        using StochasticDiffEqIIF
        using Test

        @test IIF1M() isa IIF1M
        @test IIF2M() isa IIF2M
        @test IIF1Mil() isa IIF1Mil
        @test StochasticDiffEqIIF.alg_order(IIF1M()) == 1 // 2
        @test StochasticDiffEqIIF.alg_order(IIF2M()) == 1 // 2
        @test StochasticDiffEqIIF.alg_order(IIF1Mil()) == 1 // 1
    end
end

alg_order(alg::IIF1M) = 1 // 2
alg_order(alg::IIF2M) = 1 // 2
alg_order(alg::IIF1Mil) = 1 // 1

alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::IIF1M) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::IIF2M) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::IIF1Mil) = true
